/*
 * Copyright (c) 2005-2014 Brocade Communications Systems, Inc.
 * Copyright (c) 2014 QLogic Corporation.
 * All rights reserved
 * www.qlogic.com
 *
 * See LICENSE.bfa for copyright and licensing details.
 */
#include <linux/wait.h>		/* wake_up() */
#include <linux/fs.h>		/* kill_fasync() */
#include "bfad_aen_cb.h"
#include "bfad_aen.h"

/**
 * @dg aen2bfad_api AEN module ==> Base Linux interface
 * @{
 */

/**
 * @brief BFAD callback function for AEN to inform arrival of a new event
 * @param[in] bfad  - Linux driver IOC instance ptr
 * @return          None
 */
void
bfad_aen_cb_notify(void *bfad)
{
#if  LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 31)
	bfad_aen_im_notify((struct bfad_s *)bfad);
#else
	wake_up(&bfad_aen_readq);
	if (fasync_enabled)
		kill_fasync(&bfad_aen_asyncq, SIGIO, POLL_IN);
#endif
}

/**
 * @}
 */
