/*
 * Copyright (c) 2005-2014 Brocade Communications Systems, Inc.
 * Copyright (c) 2014 QLogic Corporation.
 * All rights reserved
 * www.qlogic.com
 *
 * See LICENSE.bfa for copyright and licensing details.
 */

#ifndef __BFAD_ATTR_H__
#define __BFAD_ATTR_H__
/**
 * @file bfad_attr.h VMware driver configuration interface module.
 */

extern int supported_fc4s;

/**
 * @dg FC_transport_template FC transport template
 * @{
 */

struct Scsi_Host*
bfad_os_dev_to_shost(struct scsi_target *starget);

/**
 * @brief
 * FC transport template entry, get SCSI target port ID.
 */
void
bfad_im_get_starget_port_id(struct scsi_target *starget);

/**
 * @brief
 * FC transport template entry, get SCSI target nwwn.
 */
void
bfad_im_get_starget_node_name(struct scsi_target *starget);

/**
 * @brief
 * FC transport template entry, get SCSI target pwwn.
 */
void
bfad_im_get_starget_port_name(struct scsi_target *starget);

/**
 * @brief
 * FC transport template entry, get SCSI host port ID.
 */
void
bfad_im_get_host_port_id(struct Scsi_Host *shost);

/**
 * @brief
 * FC transport template entry, issue a LIP.
 */
int
bfad_im_issue_fc_host_lip(struct Scsi_Host *shost);

struct Scsi_Host*
bfad_os_starget_to_shost(struct scsi_target *starget);

/**
 * @brief
 * FC transport template entry, get SCSI host port type.
 */
void
bfad_im_get_host_port_type(struct Scsi_Host *shost);
/**
 * @}
 */

/**
 * @brief
 * FC transport template entry, get SCSI host port state.
 */
void
bfad_im_get_host_port_state(struct Scsi_Host *shost);

/**
 * @brief
 * FC transport template entry, get SCSI host active fc4s.
 */
void
bfad_im_get_host_active_fc4s(struct Scsi_Host *shost);

/**
 * @brief
 * FC transport template entry, get SCSI host link speed.
 */
void
bfad_im_get_host_speed(struct Scsi_Host *shost);

/**
 * @brief
 * FC transport template entry, get SCSI host port type.
 */
void
bfad_im_get_host_fabric_name(struct Scsi_Host *shost);

/**
 * @brief
 * FC transport template entry, get BFAD statistics.
 */
struct fc_host_statistics *
bfad_im_get_stats(struct Scsi_Host *shost);

/**
 * @brief
 * FC transport template entry, reset BFAD statistics.
 */
void
bfad_im_reset_stats(struct Scsi_Host *shost);

/**
 * @brief
 * FC transport template entry, get rport loss timeout.
 */
void
bfad_im_get_rport_loss_tmo(struct fc_rport *rport);

/**
 * @brief
 * FC transport template entry, set rport loss timeout.
 */
void
bfad_im_set_rport_loss_tmo(struct fc_rport *rport, uint32_t timeout);

/**
 * @}
 */
#endif /*  __BFAD_ATTR_H__ */
