/*
 * Copyright (c) 2005-2014 Brocade Communications Systems, Inc.
 * Copyright (c) 2014 QLogic Corporation.
 * All rights reserved
 * www.qlogic.com
 * See LICENSE.bfa for copyright and licensing details.
 */
#ifndef BFAD_BSG_H
#define BFAD_BSG_H

#include "bfa_os_inc.h"
#include "bfad_ioctl_cna.h"
#include "bfad_ioctl.h"
#include <defs/bfa_defs.h>

/* AEN */
typedef bfa_ioctl_aen_t bfa_bsg_aen_t;

/* IOC */
typedef bfa_ioctl_ioc_attr_t bfa_bsg_ioc_attr_t;
typedef bfa_ioctl_ioc_info_t bfa_bsg_ioc_info_t;
typedef bfa_ioctl_ioc_stats_t bfa_bsg_ioc_stats_t;
typedef bfa_ioctl_gen_t bfa_bsg_gen_t;
typedef bfa_ioctl_ioc_set_adapter_name_t bfa_bsg_ioc_set_adapter_name_t;
typedef bfa_ioctl_ioc_fwstats_t bfa_bsg_ioc_fwstats_t;
typedef bfa_ioctl_pcifn_cfg_t bfa_bsg_pcifn_cfg_t;

/* IOCFC */
typedef bfa_ioctl_iocfc_attr_t bfa_bsg_iocfc_attr_t;
typedef bfa_ioctl_iocfc_intr_t bfa_bsg_iocfc_intr_t;

/* PORT */
typedef bfa_ioctl_port_stats_t bfa_bsg_port_stats_t;
typedef bfa_ioctl_port_attr_t bfa_bsg_port_attr_t;
typedef bfa_ioctl_port_cfg_topo_t bfa_bsg_port_cfg_topo_t;
typedef bfa_ioctl_port_cfg_speed_t bfa_bsg_port_cfg_speed_t;
typedef bfa_ioctl_port_alpa_t bfa_bsg_port_alpa_t;
typedef bfa_ioctl_port_cfg_maxfrsize_t bfa_bsg_port_cfg_maxfrsize_t;

/* LPORT */
typedef bfa_ioctl_lport_stats_t bfa_bsg_lport_stats_t;
typedef bfa_ioctl_lport_reset_stats_t bfa_bsg_lport_reset_stats_t;
typedef bfa_ioctl_lport_iostats_t bfa_bsg_lport_iostats_t;
typedef bfa_ioctl_lport_attr_t bfa_bsg_lport_attr_t;
typedef bfa_ioctl_lport_get_rports_t bfa_bsg_lport_get_rports_t;

/* RPORT */
typedef bfa_ioctl_rport_attr_t bfa_bsg_rport_attr_t;
typedef bfa_ioctl_rport_stats_t bfa_bsg_rport_stats_t;
typedef bfa_ioctl_rport_reset_stats_t bfa_bsg_rport_reset_stats_t;
typedef bfa_ioctl_rport_scsi_addr_t bfa_bsg_rport_scsi_addr_t;
typedef bfa_ioctl_rport_set_speed_t bfa_bsg_rport_set_speed_t;

/* VPORT */
typedef bfa_ioctl_vport_t bfa_bsg_vport_t;
typedef bfa_ioctl_vport_attr_t bfa_bsg_vport_attr_t;
typedef bfa_ioctl_vport_stats_t bfa_bsg_vport_stats_t;
typedef bfa_ioctl_vport_reset_stats_t bfa_bsg_vport_reset_stats_t;

/* VF */
typedef bfa_ioctl_vf_t bfa_bsg_vf_t;
typedef bfa_ioctl_vf_add_t bfa_bsg_vf_add_t;
typedef bfa_ioctl_vf_list_t bfa_bsg_vf_list_t;
typedef bfa_ioctl_vf_attr_t bfa_bsg_vf_attr_t;
typedef bfa_ioctl_vf_stats_t bfa_bsg_vf_stats_t;
typedef bfa_ioctl_vf_reset_stats_t bfa_bsg_vf_reset_stats_t;

/* FABRIC */
typedef bfa_ioctl_fabric_get_lports_t bfa_bsg_fabric_get_lports_t;

/* FLASH */
typedef bfa_ioctl_flash_attr_t bfa_bsg_flash_attr_t;
typedef bfa_ioctl_flash_t bfa_bsg_flash_t;
typedef bfa_ioctl_flash_mfg_t bfa_bsg_flash_mfg_t;

/* PHY */
typedef bfa_ioctl_phy_attr_t bfa_bsg_phy_attr_t;
typedef bfa_ioctl_phy_stats_t bfa_bsg_phy_stats_t;
typedef bfa_ioctl_phy_t bfa_bsg_phy_t;

/* CEE */
typedef bfa_ioctl_cee_attr_t bfa_bsg_cee_attr_t;
typedef bfa_ioctl_cee_stats_t bfa_bsg_cee_stats_t;

/* SFP */
typedef bfa_ioctl_sfp_media_t bfa_bsg_sfp_media_t;
typedef bfa_ioctl_sfp_speed_t bfa_bsg_sfp_speed_t;
typedef bfa_ioctl_sfp_show_t bfa_bsg_sfp_show_t;

typedef bfa_ioctl_log_t bfa_bsg_log_t;

/* QoS */
typedef bfa_ioctl_qos_attr_t bfa_bsg_qos_attr_t;
typedef bfa_ioctl_qos_vc_attr_t bfa_bsg_qos_vc_attr_t;
typedef bfa_ioctl_qos_stats_t bfa_bsg_qos_stats_t;

typedef bfa_ioctl_trl_speed_t bfa_bsg_trl_speed_t;

/* FCPIM */
typedef bfa_ioctl_fcpim_t bfa_bsg_fcpim_t;
typedef bfa_ioctl_fcpim_qdepth_t bfa_bsg_fcpim_qdepth_t;
typedef bfa_ioctl_fcpim_modstats_t bfa_bsg_fcpim_modstats_t;
typedef bfa_ioctl_fcpim_modstatsclr_t bfa_bsg_fcpim_modstatsclr_t;
typedef bfa_ioctl_fcpim_del_itn_stats_t bfa_bsg_fcpim_del_itn_stats_t;
typedef bfa_ioctl_fcpim_lunmask_t bfa_bsg_fcpim_lunmask_t;
typedef bfa_ioctl_fcpim_lunmask_query_t bfa_bsg_fcpim_lunmask_query_t;
typedef bfa_ioctl_fcpim_throttle_t bfa_bsg_fcpim_throttle_t;
typedef bfa_ioctl_fcpim_iopf_t bfa_bsg_fcpim_iopf_t;
typedef bfa_ioctl_fcpim_iopf_show_t bfa_bsg_fcpim_iopf_show_t;
typedef bfa_ioctl_fcpim_iopf_query_t bfa_bsg_fcpim_iopf_query_t;

/* BOOT */
typedef bfa_ioctl_boot_t bfa_bsg_boot_t;
typedef bfa_ioctl_preboot_t bfa_bsg_preboot_t;

/* ITNIM */
typedef bfa_ioctl_itnim_attr_t bfa_bsg_itnim_attr_t;
typedef bfa_ioctl_itnim_iostats_t bfa_bsg_itnim_iostats_t;
typedef bfa_ioctl_itnim_reset_stats_t bfa_bsg_itnim_reset_stats_t;
typedef bfa_ioctl_itnim_itnstats_t bfa_bsg_itnim_itnstats_t;

/* AUTH */
typedef bfa_ioctl_auth_attr_t bfa_bsg_auth_attr_t;
typedef bfa_ioctl_auth_stats_t bfa_bsg_auth_stats_t;
typedef bfa_ioctl_auth_policy_t bfa_bsg_auth_policy_t;
typedef bfa_ioctl_auth_algo_t bfa_bsg_auth_algo_t;
typedef bfa_ioctl_auth_group_t bfa_bsg_auth_group_t;
typedef bfa_ioctl_auth_secretstring_t bfa_bsg_auth_secretstring_t;
typedef bfa_ioctl_auth_secretsource_t bfa_bsg_auth_secretsource_t;

typedef bfa_ioctl_fcport_stats_t bfa_bsg_fcport_stats_t;
typedef bfa_ioctl_trunk_attr_t bfa_bsg_trunk_attr_t;

typedef bfa_ioctl_faa_attr_t bfa_bsg_faa_attr_t;

/* DEBUG */
typedef bfa_ioctl_debug_t bfa_bsg_debug_t;
typedef bfa_ioctl_portlogctl_t bfa_bsg_portlogctl_t;

/* DIAG */
typedef bfa_ioctl_diag_kva_t bfa_bsg_diag_kva_t;
typedef bfa_ioctl_diag_get_temp_t bfa_bsg_diag_get_temp_t;
typedef bfa_ioctl_diag_memtest_t bfa_bsg_diag_memtest_t;
typedef bfa_ioctl_diag_loopback_t bfa_bsg_diag_loopback_t;
typedef bfa_ioctl_diag_fwping_t bfa_bsg_diag_fwping_t;
typedef bfa_ioctl_diag_qtest_t bfa_bsg_diag_qtest_t;
typedef bfa_ioctl_diag_pom_t bfa_bsg_diag_pom_t;
typedef bfa_ioctl_diag_led_t bfa_bsg_diag_led_t;
typedef bfa_ioctl_diag_beacon_t bfa_bsg_diag_beacon_t;
typedef bfa_ioctl_diag_lb_stat_t bfa_bsg_diag_lb_stat_t;

/* PICFN */
typedef bfa_ioctl_pcifn_t bfa_bsg_pcifn_t;

/* VHBA */
typedef bfa_ioctl_vhba_attr_t bfa_bsg_vhba_attr_t;

/* TARGET MODE */
typedef bfa_tgt_mode_ioctl_t bfa_bsg_tgt_mode_t;

struct bfa_bsg_fcpt_s {
	bfa_status_t    status;
	uint16_t	vf_id;
	wwn_t		lpwwn;
	wwn_t		dpwwn;
	uint32_t	tsecs;
	boolean_t	cts;
	fc_cos_t	cos;
	fchs_t		fchs;
};
typedef struct bfa_bsg_fcpt_s bfa_bsg_fcpt_t;

#pragma pack(1)
struct bfa_bsg_data {
	int payload_len;
	uint64_t payload;
};
#pragma pack()

#endif /* BFAD_BSG_H */
