/*
 * Copyright (c) 2005-2014 Brocade Communications Systems, Inc.
 * Copyright (c) 2014 QLogic Corporation.
 * All rights reserved
 * www.qlogic.com
 *
 * See LICENSE.bfa for copyright and licensing details.
 */

/**
 * @file bfa_fcs_ops.c BFA FCS TM interface
 */

#include <fcs/bfa_fcs_tmops.h>
#include <fcs/bfa_fcs.h>

static struct bfa_fcs_tm_ops_s bfa_fcs_tm_ops;

void
bfa_fcs_tmops_init(bfa_fcs_t *fcs)
{
	fcs->tm_ops = &bfa_fcs_tm_ops;
}

void
bfa_fcs_tmops_exit()
{
}

void
bfa_fcs_tm_register(struct bfa_fcs_tm_ops_s *fcs_tm_ops)
{
	bfa_fcs_tm_ops = *fcs_tm_ops;
}

void
bfa_fcs_tm_unregister()
{
	bfa_os_memset(&bfa_fcs_tm_ops, 0,
		sizeof(struct bfa_fcs_tm_ops_s));
}
