/*
 * Copyright (c) 2005-2014 Brocade Communications Systems, Inc.
 * Copyright (c) 2014 QLogic Corporation.
 * All rights reserved
 * www.qlogic.com
 *
 * See LICENSE.bfa for copyright and licensing details.
 */
#include <bfa/bfa_modules.h>
#include <bfa/bfa_tmops.h>

/**
 * BFA TM interface related definitions
 */

static struct bfa_tm_ops_s bfa_tm_ops;

void
bfa_tmops_init(struct bfa_s *bfa)
{
	bfa->tm_ops = &bfa_tm_ops;
}

void
bfa_tmops_exit(struct bfa_s *bfa)
{
}

void
bfa_tm_register(struct bfa_tm_ops_s *tm_ops)
{
	bfa_tm_ops = *tm_ops;

	bfa_isr_bind(BFI_MC_TIO_DATA_XFERED, bfa_tm_ops.tiods_isr);
	bfa_isr_bind(BFI_MC_TIO_IO, bfa_tm_ops.tio_isr);
	bfa_isr_bind(BFI_MC_TIO, bfa_tm_ops.tio_comp_isr);
}

void
bfa_tm_unregister(void)
{
	bfa_os_memset(&bfa_tm_ops, 0, sizeof(struct bfa_tm_ops_s));

	bfa_isr_bind(BFI_MC_TIO_DATA_XFERED, bfa_isr_unhandled);
	bfa_isr_bind(BFI_MC_TIO_IO, bfa_isr_unhandled);
	bfa_isr_bind(BFI_MC_TIO, bfa_isr_unhandled);
}
