/*
 * Copyright (c) 2005-2014 Brocade Communications Systems, Inc.
 * Copyright (c) 2014 QLogic Corporation.
 * All rights reserved
 * www.qlogic.com
 *
 * See LICENSE.bfa for copyright and licensing details.
 */
/*
 * bfa_dconf.h flash content of flash partition
 */

#ifndef __BFA_DCONF_H_
#define __BFA_DCONF_H_

#include <bfa/bfa_modules.h>
#include <bfi/bfi_pbind.h>

#define BFI_DCONF_SIGNATURE	0xabcdabcd
#define BFI_DCONF_VERSION	1

struct bfa_dconf_mod_s {
	bfa_sm_t	sm;
	uint8_t		instance;
	bfa_boolean_t	read_data_valid;
	bfa_boolean_t	min_cfg;
	bfa_timer_t	timer;
	struct bfa_s	*bfa;
	void		*bfad;
	void		*trcmod;
	struct bfa_dconf_s *dconf;
	struct bfa_mem_kva_s	kva_seg;
};
typedef struct bfa_dconf_mod_s bfa_dconf_mod_t;

#define BFA_DCONF_MOD(__bfa)  		\
	(&(__bfa)->modules.dconf_mod)
#define BFA_MEM_DCONF_KVA(__bfa)	(&(BFA_DCONF_MOD(__bfa)->kva_seg))
#define bfa_dconf_read_data_valid(__bfa) 	\
	BFA_DCONF_MOD(__bfa)->read_data_valid
#define BFA_DCONF_UPDATE_TOV	5000    /* !< memtest timeout in msec */
#define bfa_dconf_get_min_cfg(__bfa)	\
	(BFA_DCONF_MOD(__bfa)->min_cfg)

void bfa_dconf_modinit(bfa_t *bfa);
void bfa_dconf_modexit(bfa_t *bfa);
bfa_status_t  bfa_dconf_update(struct bfa_s *bfa);
#endif
