/*
 * Copyright (c) 2005-2014 Brocade Communications Systems, Inc.
 * Copyright (c) 2014 QLogic Corporation.
 * All rights reserved
 * www.qlogic.com
 *
 * See LICENSE.bfa for copyright and licensing details.
 */

#ifndef __BFI_IPFC_H__
#define __BFI_IPFC_H__

#include <bfi/bfi.h>

#pragma pack(1)

typedef enum {
	BFI_IPFC_H2I_POST	= 1,
	BFI_IPFC_H2I_FLUSH	= 2,
} bfi_ipfc_h2i_t;

typedef enum {
	BFI_IPFC_I2H_RECV	= BFA_I2HM(1),
	BFI_IPFC_I2H_FLUSH_COMP	= BFA_I2HM(2),
} bfi_ipfc_i2h_t;

#define BFA_IPFC_MAX_SGES	2

typedef struct {
	struct bfi_mhdr_s mh;		/*!< Common msg header		*/
	uint16_t	pkt_tag;	/*!< packet tag			*/
	uint16_t	buf_len;	/*!< receive buffer length	*/
	struct bfi_alen_s alen;		/*!< packet DMA addr+len	*/
} bfi_ipfc_post_t;

typedef struct {
	struct bfi_mhdr_s mh;		/*!< Common msg header		*/
	uint16_t	pkt_tag;	/*!< packet tag			*/
	uint16_t	rsvd;
} bfi_ipfc_flush_t;

typedef struct {
	struct bfi_mhdr_s mh;		/*!< Common msg header		*/
	uint16_t	pkt_tag;	/*!< packet tag			*/
	uint16_t	pkt_len;	/*!< received packet length 	*/
	uint16_t	xfr_len;	/*!< tranferred length		*/
	uint16_t	rsvd;
} bfi_ipfc_recv_t;

typedef struct {
	struct bfi_mhdr_s mh;		/*!< Common msg header		*/
	uint16_t	pkt_tag;	/*!< packet tag			*/
	uint16_t	rsvd;
} bfi_ipfc_flush_rsp_t;

typedef union {
	struct bfi_msg_s	*msg;
	bfi_ipfc_post_t	*post;
} bfi_ipfc_h2i_msg_t;

typedef union {
	struct bfi_msg_s	msg;
	bfi_ipfc_recv_t		recv;
	bfi_ipfc_flush_rsp_t	flush_rsp;
} bfi_ipfc_i2h_msg_t;

#pragma pack()

#endif /* __BFI_IPFC_H__ */
