/*
 * Copyright (c) 2005-2014 Brocade Communications Systems, Inc.
 * Copyright (c) 2014 QLogic Corporation.
 * All rights reserved
 * www.qlogic.com
 *
 * See LICENSE.bfa for copyright and licensing details.
 */

/*
 * bfi_pbind.h
 */

#ifndef __BFI_PBIND_H__
#define __BFI_PBIND_H__

#pragma pack(1)


#define BFI_PBIND_SIGNATURE         0xbeedbaba
#define BFI_PBIND_SIGNATURE_LEN     8
#define BFI_PBIND_VERSION           1

#define BFI_PBIND_DEF_CFG_NUM_BINDING	1024 /*!< should be same as DEF_CFG_NUM_ITNIMS */

/**
 * target persistent binding entry in flash.
 */
typedef struct {
    wwn_t           rpwwn;      /*!< remote target port wwn */
    wwn_t           lpwwn;      /*!< scope: local port (base or vport) */
	uint8_t			bus;     	/*!< mapped OS bus number */
	uint8_t			target;   	/*!< mapped OS target number */
	uint8_t			rsvd[14];	/*!< for future expansion */
} bfi_pbind_entry_t;

/**
 * pbind header
 */
typedef struct {
    uint64_t            signature;
    uint32_t        	num_pbind_entries;
    uint8_t        		version;
	uint8_t				rsvd[19];
}bfi_pbind_hdr_t;

typedef struct {
	bfi_pbind_hdr_t		hdr;
    bfi_pbind_entry_t 	map[BFI_PBIND_DEF_CFG_NUM_BINDING];
} bfi_pbind_t;

#pragma pack()

#endif

