/*
 * Copyright (c) 2005-2014 Brocade Communications Systems, Inc.
 * Copyright (c) 2014 QLogic Corporation.
 * All rights reserved
 * www.qlogic.com
 *
 * See LICENSE.bfa for copyright and licensing details.
 */

#ifndef __BFA_DEFS_IM_TEAM_H__
#define __BFA_DEFS_IM_TEAM_H__

#include <bfa_defs_im_common.h>
#include <bfa_defs.h>

#pragma pack(1)
typedef struct {		
	bfa_im_team_mode_t     team_mode;
	bfa_im_lacp_rate_t     lacp_rate;
	bfa_im_xmit_policy_t   xmit_policy;
	int   	         	   delay;
	wchar_t    	           primary[BFA_ADAPTER_NAME_LEN];
	wchar_t    	           bundle_id[BFA_ADAPTER_NAME_LEN];/*unique guid used for team reference inside the driver*/
	wchar_t    	           active_link[BFA_ADAPTER_NAME_LEN];/*current active adapter on which the traffic is going thru*/
	mac_addr	           mac;
	uint16_t       		   num_ports;
	uint16_t         	   num_vlans;
	uint16_t			   vlan_list[BFA_MAX_VLANS_PER_PORT];
	wchar_t				   team_guid_list[BFA_TEAM_MAX_PORTS][BFA_ADAPTER_GUID_LEN];
	int					   team_mac_owner_index;
	wchar_t				   ioc_name_list[BFA_TEAM_MAX_PORTS][BFA_ADAPTER_NAME_LEN];
	bfa_status_t			port_status[BFA_TEAM_MAX_PORTS];
} bfa_im_team_attr_t;

typedef struct {
	wchar_t		             team_name[BFA_TEAM_NAME_LEN];
	bfa_im_xmit_policy_t	 xmit_policy;
	int                 	 delay;
	wchar_t                	 primary[BFA_ADAPTER_NAME_LEN];
}bfa_im_team_edit_t, *pbfa_im_team_edit_t;

typedef struct {
	wchar_t					team_name[BFA_TEAM_NAME_LEN];
	bfa_im_team_mode_t      team_mode;
	mac_addr	            mac;
}bfa_im_team_info_t;

typedef struct {
	bfa_im_team_info_t 		team_info[BFA_MAX_NUM_TEAMS];
	uint16_t 				num_teams;
} bfa_im_team_list_t, *pbfa_im_team_list_t;
#pragma pack()

#endif /* __BFA_DEFS_IM_TEAM_H__ */
