/*
 * Copyright (c) 2005-2014 Brocade Communications Systems, Inc.
 * Copyright (c) 2014 QLogic Corporation.
 * All rights reserved
 * www.qlogic.com
 *
 * See LICENSE.bfa for copyright and licensing details.
 */

#ifndef __BFA_DEFS_IM_VLAN_H__
#define __BFA_DEFS_IM_VLAN_H__

#include <stdint.h>
#include <bfa_defs_im_common.h>

typedef struct {   
	uint16_t	port_id;/* pci dev number (TBD) */
	uint16_t   	vlan_id;
	wchar_t vlan_name[BFA_VLAN_NAME_LEN];
	wchar_t adapter_name[BFA_ADAPTER_GUID_LEN];
	wchar_t netcfg_id[BFA_ADAPTER_GUID_LEN];
} bfa_im_vlan_t;

typedef struct {
	uint16_t vlan_id;
	wchar_t vlan_name[BFA_VLAN_NAME_LEN];
}bfa_im_vlan_id_t, *pbfa_im_vlan_id_t;

typedef struct {
	wchar_t netcfg_id[BFA_ADAPTER_GUID_LEN];
	bfa_im_vlan_id_t vlan_id[BFA_MAX_VLANS_PER_PORT];
	uint16_t num_vlan_ids;
} bfa_im_vlan_id_list_t, *pbfa_im_vlan_id_list_t;

#endif /* __BFA_DEFS_IM_VLAN_H__ */

