/*
 * Copyright (c) 2005-2014 Brocade Communications Systems, Inc.
 * Copyright (c) 2014 QLogic Corporation.
 * All rights reserved
 * www.qlogic.com
 *
 * See LICENSE.bfa for copyright and licensing details.
 */

#ifndef __BFA_DEFS_PBIND_H__
#define __BFA_DEFS_PBIND_H__

#include <protocol/bfa_fc.h>

/**
 * @ig cs_pbind_doc
 * @{
 */
#define BFA_PBIND_MAKE_OSTID(bus, target)	\
	(((uint16_t)(bus) << BFAD_CONFIG_MAX_TARGETS_PER_BUS_SHIFT) | (target))
#define BFA_PBIND_GET_OSBUS(os_tid)		\
	(uint8_t)((os_tid) >> BFAD_CONFIG_MAX_TARGETS_PER_BUS_SHIFT)
#define BFA_PBIND_GET_OSTARGET(os_tid)		\
	(uint8_t)((os_tid) & ((1 << BFAD_CONFIG_MAX_TARGETS_PER_BUS_SHIFT) - 1))

#define BFA_PBIND_BY_DID	0x0001
#define BFA_PBIND_BY_PWWN	0x0002
#define BFA_PBIND_BY_NWWN	0x0004
#define BFA_PBIND_BY_LUID       0x0008
#define BFA_PBIND_BY_LUNS       0x0400
#define BFA_PBIND_BY_TARGETS    0x0800
#define BFA_PBIND_BY_AUTOMAP    0x1000
#define BFA_PBIND_BY_CONFIGURED 0x2000

/**
 * Target persistent binding entry in memory.
 */
struct bfa_pbind_map_s {
	wwn_t           rpwwn;		/*!< remote target port wwn */
	wwn_t           lpwwn;		/*!< scope: local port (base or vport) */
	uint16_t        os_tid;		/*!< mapped OS target ID */
	uint8_t        	rsvd[6];
};
typedef struct bfa_pbind_map_s bfa_pbind_map_t;

/**
 * @}
 */
#endif /* __BFA_DEFS_PBIND_H__ */
