/*
 * Copyright (c) 2005-2014 Brocade Communications Systems, Inc.
 * Copyright (c) 2014 QLogic Corporation.
 * All rights reserved
 * www.qlogic.com
 *
 * See LICENSE.bfa for copyright and licensing details.
 */

#ifndef __BFA_FCS_IPFC_H__
#define __BFA_FCS_IPFC_H__

#include <defs/bfa_defs.h>
#include <defs/bfa_defs_ipfc.h>
#include <fcs/bfa_fcs.h>

/*
 * forward declarations
 */
typedef struct bfad_iprp_s bfad_iprp_t;

struct bfa_fcs_iprp_s {
	struct bfa_fcs_s      *fcs;	/*!< fcs instance */
	bfad_iprp_t    	*rp_drv;	/*!< driver peer instance */
	bfa_sm_t	sm;	/*!< state machine */
	struct bfa_fcs_rport_s *rport;	/*!< FCP initiator mode role */
};

static inline struct bfad_port_s *
bfa_fcs_ipfc_get_drvport(struct bfa_fcs_iprp_s *iprp)
{
	return iprp->rport->port->bfad_port;
}

/**
 * bfa fcs rport API functions
 */
void            bfa_fcs_iprp_get_attr(struct bfa_fcs_iprp_s *rport,
				      struct bfa_iprp_attr_s *attr);
void            bfa_fcs_iprp_get_stats(struct bfa_fcs_iprp_s *rport,
				       struct bfa_iprp_stats_s *stats);
void            bfa_fcs_iprp_login(struct bfa_fcs_lport_s *port, wwn_t *pwwn,
				   uint32_t pid, struct bfa_fcs_iprp_s *iprp,
				   bfad_iprp_t *iprp_drv);
void            bfa_fcs_iprp_logout(struct bfa_fcs_iprp_s *iprp);

#endif /* __BFA_FCS_IPFC_H__ */
