/*
 * Copyright (c) 2005-2014 Brocade Communications Systems, Inc.
 * Copyright (c) 2014 QLogic Corporation.
 * All rights reserved
 * www.qlogic.com
 *
 * See LICENSE.bfa for copyright and licensing details.
 */

#ifndef __BFA_FCS_TMOPS_H__
#define __BFA_FCS_TMOPS_H__

#include <protocol/bfa_fc.h>

/* Target driver FCS interfaces */
struct bfa_fcs_rport_s;
struct bfa_fcs_s;
typedef struct bfa_fcs_tm_ops_s {
	struct bfa_fcs_tin_s * (*tin_create)(struct bfa_fcs_rport_s *rport);
	void (*tin_delete)(struct bfa_fcs_tin_s *tin);
	void (*tin_offline)(struct bfa_fcs_tin_s *tin);
	void (*tin_rx_prli)(struct bfa_fcs_tin_s *tin, fchs_t *fchs);
	void (*tin_rx_prlo)(struct bfa_fcs_tin_s *tin, fchs_t *fchs);
}bfa_fcs_tm_ops_t;

void bfa_fcs_tmops_init(struct bfa_fcs_s *fcs);
void bfa_fcs_tmops_exit(void);
void bfa_fcs_tm_register(struct bfa_fcs_tm_ops_s *fcs_tm_ops);
void bfa_fcs_tm_unregister(void);

#endif
