/*
 * Copyright (c) 2005-2014 Brocade Communications Systems, Inc.
 * Copyright (c) 2014 QLogic Corporation.
 * All rights reserved
 * www.qlogic.com
 *
 * See LICENSE.bfa for copyright and licensing details.
 */

#ifndef __BFA_IOCTL_AUTH_H__
#define __BFA_IOCTL_AUTH_H__

#include <defs/bfa_defs_fcs.h>

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        rsvd;
	struct bfa_auth_attr_s attr;
} bfa_ioctl_auth_attr_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        rsvd;
	struct bfa_auth_stats_s stats;
} bfa_ioctl_auth_stats_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        rsvd;
	bfa_boolean_t   mode;
	uint32_t        rsvd1;
} bfa_ioctl_auth_policy_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        rsvd;
	enum bfa_auth_algo algo;
	uint32_t        rsvd1;
} bfa_ioctl_auth_algo_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        rsvd;
	enum bfa_auth_group group;
	uint32_t        rsvd1;
} bfa_ioctl_auth_group_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        rsvd;
	enum bfa_auth_secretsource source;
	uint32_t        rsvd1;
} bfa_ioctl_auth_secretsource_t;


typedef struct {
	bfa_status_t	status;
	uint16_t     	bfad_num;
	uint16_t        len;
	uint32_t     	encrypt[BFA_AUTH_SECRET_STRING_LEN];
	char	     	secret[BFA_AUTH_SECRET_STRING_LEN];
} bfa_ioctl_auth_secretstring_t;

#endif
