/*
 * Copyright (c) 2005-2014 Brocade Communications Systems, Inc.
 * Copyright (c) 2014 QLogic Corporation.
 * All rights reserved
 * www.qlogic.com
 *
 * See LICENSE.bfa for copyright and licensing details.
 */

#ifndef __BFA_IOCTL_FCPIM_H__
#define __BFA_IOCTL_FCPIM_H__

#include <defs/bfa_defs_svc.h>

typedef struct {
	bfa_status_t	status;
	uint16_t	bfad_num;
	uint16_t	path_tov;
} bfa_ioctl_fcpim_t;

typedef struct {
	bfa_status_t	status;
	uint16_t	bfad_num;
	uint16_t	q_depth;
	uint32_t	rsvd[2];
} bfa_ioctl_fcpim_qdepth_t;

typedef struct {
	bfa_status_t	status;
	uint16_t	bfad_num;
	bfa_itnim_iostats_t modstats;
	/* modstats is accululated for all ITNIM */
} bfa_ioctl_fcpim_modstats_t;

typedef struct {
	bfa_status_t	status;
	uint16_t	bfad_num;
	bfa_fcpim_del_itn_stats_t modstats;
} bfa_ioctl_fcpim_del_itn_stats_t;


typedef struct {
	bfa_status_t	status;
	uint16_t	bfad_num;
} bfa_ioctl_fcpim_modstatsclr_t;

typedef struct {
	bfa_status_t    status;
	uint16_t    bfad_num;
	struct bfa_lunmask_cfg_s lun_mask;
}bfa_ioctl_fcpim_lunmask_query_t;

typedef struct {
	bfa_status_t    status;
	uint16_t    bfad_num;
	uint16_t    vf_id;
	wwn_t   pwwn;
	wwn_t   rpwwn;
	lun_t lun;
}bfa_ioctl_fcpim_lunmask_t;

typedef struct {
	bfa_status_t    status;
	uint16_t    bfad_num;
	uint16_t    vf_id;
	wwn_t   pwwn;
	wwn_t   rpwwn;
	lun_t lun;
	uint32_t flow_count;
	uint32_t rsvd;
	/** * mem is for BFA_IOPF_MAX * sizeof(bfa_fcpim_iopf_cfg_t) */
#ifdef _WINDOWS
	struct bfa_fcpim_iopf_cfg_s iopf_cfg[1];
#else
	uint64_t iopf_cfg;
#endif

}bfa_ioctl_fcpim_iopf_query_t;

typedef struct {
	bfa_status_t    status;
	uint16_t    bfad_num;
	uint16_t    vf_id;
	enum bfa_fcpim_iopf_lun_type all_range;
	int flow_count;
	wwn_t   pwwn;
	wwn_t   rpwwn;
	lun_t lun[BFA_IOPF_MAX];
	uint8_t lun_status[BFA_IOPF_MAX];
}bfa_ioctl_fcpim_iopf_t;

typedef struct {
	bfa_status_t    status;
	uint16_t    bfad_num;
	uint16_t    vf_id;
	int itn_lun;
	int rsvd;
	wwn_t   pwwn;
	wwn_t   rpwwn;
	lun_t lun;
	struct bfa_fcpim_iopf_s iopf;
}bfa_ioctl_fcpim_iopf_show_t;

typedef struct {
	bfa_status_t    status;
	uint16_t    bfad_num;
	uint16_t    vf_id;
	bfa_defs_fcpim_throttle_t throttle;
} bfa_ioctl_fcpim_throttle_t;
#endif
