/*
 * Copyright (c) 2005-2014 Brocade Communications Systems, Inc.
 * Copyright (c) 2014 QLogic Corporation.
 * All rights reserved
 * www.qlogic.com
 *
 * See LICENSE.bfa for copyright and licensing details.
 */

#ifndef __BFA_IOCTL_IM_TEAM_H__
#define __BFA_IOCTL_IM_TEAM_H__

#include "bfa_defs.h"
#include "bfa_defs_im_team.h"
#include "bfa_defs_im_common.h"

#pragma pack(1)

typedef struct _tag_bni_ioctl_team_query {
	bfa_status_t	status;
	GUID			team_id;
	GUID 			active_link;
	GUID 			mac_owner;
	bni_stats_t		stats;
	mac_addr		mac;
} bni_ioctl_team_query_t;

typedef struct _tag_bni_ioctl_team_mac {
	bfa_status_t	status;
	GUID			team_id;
	mac_addr		mac;
} bni_ioctl_team_mac_t;

//to change the primary port
typedef struct _tag_bni_ioctl_team_primary {
	bfa_status_t	status;
	GUID			team_id;
	GUID			primary;
} bni_ioctl_team_primary_edit_t;

typedef enum bni_xmit_policy_e {
	BNI_XMIT_POLICY_L2 = 1,
	BNI_XMIT_POLICY_L3_L4
}bni_xmit_policy_t;

//to change the xmitpolicy
typedef struct _tag_bni_ioctl_xmit_policy {
	bfa_status_t	status;
	GUID			team_id;
	bni_xmit_policy_t policy;
} bni_ioctl_team_xmit_policy_edit_t;

typedef struct {
	bfa_status_t	        status;
	wchar_t            		team_name[BFA_TEAM_NAME_LEN];
	bfa_im_stats_t			stats;
	bfa_im_team_attr_t		team_attr;
	wchar_t             	team_list[BFA_TEAM_MAX_PORTS][BFA_ADAPTER_GUID_LEN];
} bfa_ioctl_team_query_t, *pbfa_ioctl_team_query_t;

typedef struct {
	bfa_status_t   		status;
	bfa_im_team_list_t  team_info_list;
} bfa_ioctl_team_list_t, *pbfa_ioctl_team_list_t;

typedef struct {
	bfa_status_t        	status;
	wchar_t            		team_name[BFA_TEAM_NAME_LEN];
	bfa_im_team_edit_t		team_info_edit;
} bfa_ioctl_team_edit_t, *pbfa_ioctl_team_edit_t;

typedef struct {
	bfa_status_t        	status;
	wchar_t            		team_name[BFA_TEAM_NAME_LEN];
	wchar_t					adapter_list[BFA_TEAM_MAX_PORTS][BFA_ADAPTER_GUID_LEN];
	int						num_adapters;
}bfa_ioctl_team_portlist_t, *pbfa_ioctl_team_portlist_t;

#pragma pack()


#endif /* __BFA_IOCTL_IM_TEAM_H__ */
