/*
 * Copyright (c) 2005-2014 Brocade Communications Systems, Inc.
 * Copyright (c) 2014 QLogic Corporation.
 * All rights reserved
 * www.qlogic.com
 *
 * See LICENSE.bfa for copyright and licensing details.
 */

#ifndef __BFA_IOCTL_IM_VLAN_H__
#define __BFA_IOCTL_IM_VLAN_H__

#include "bfa_defs.h"
#include "bfa_defs_im_vlan.h"
#include "bfa_defs_im_common.h"
#include "bfa_ioctl_diag.h"

#pragma pack(1)

typedef struct _tag_bni_ioctl_vlan_stats {
	bfa_status_t        status;
	bni_stats_t			stats;
	uint16_t			vlan_id;
	GUID				bni_guid;
} bni_ioctl_vlan_stats_t;

typedef struct {
	bfa_status_t        status;
	bfa_im_vlan_t	    vlan_info;
	bfa_im_stats_t		stats;
	wchar_t             guid_str[BFA_ADAPTER_GUID_LEN];
} bfa_ioctl_vlan_query_t, *pbfa_ioctl_vlan_query_t;

typedef struct {
	bfa_status_t    		status;
	bfa_im_vlan_id_list_t 	vlan_id_list;
	int 					is_pvid_present;
} bfa_ioctl_vlan_list_t, *pbfa_ioctl_vlan_list_t;

typedef struct {
	bfa_status_t        status;
	bfa_im_vlan_t	    vlan_info;
	wchar_t             new_vlan_name[BFA_VLAN_NAME_LEN];
} bfa_ioctl_vlan_edit_t, *pbfa_ioctl_vlan_edit_t;


/* Windows intermediate driver ethernet loopback */
typedef struct {
	bfa_ioctl_diag_ll_loopback_t    diag_ll_loopback;
	wchar_t  					    adapter_id[BFA_ADAPTER_SYM_NAME_LEN];
	int 						  	vlanId;
} bfa_ioctl_diag_im_loopback_t, *pbfa_ioctl_diag_im_loopback_t;

#pragma pack()


#endif /* __BFAL_IOCTL_IM_VLAN_H__ */
