/*
 * Copyright (c) 2005-2014 Brocade Communications Systems, Inc.
 * Copyright (c) 2014 QLogic Corporation.
 * All rights reserved
 * www.qlogic.com
 *
 * See LICENSE.bfa for copyright and licensing details.
 */

#ifndef __BFA_IOCTL_ITNIM_H__
#define __BFA_IOCTL_ITNIM_H__

#include <defs/bfa_defs_fcs.h>

typedef struct {
	bfa_status_t	status;
	uint16_t	bfad_num;
	uint16_t	vf_id;
	wwn_t	lpwwn;
	wwn_t	rpwwn;
	struct bfa_itnim_attr_s attr;
} bfa_ioctl_itnim_attr_t;

typedef struct {
	bfa_status_t	status;
	uint16_t	bfad_num;
	uint16_t	vf_id;
	wwn_t	lpwwn;
	wwn_t	rpwwn;
	struct bfa_itnim_iostats_s iostats;
} bfa_ioctl_itnim_iostats_t;

typedef struct {
	bfa_status_t	status;
	uint16_t	bfad_num;
	uint16_t	trs_count;
#ifdef _WINDOWS
	struct bfa_trs_list_s trs_list[1];
#else
	uint64_t	trs_list;
#endif
} bfa_ioctl_itnim_trs_cfg_t;

typedef struct {
	bfa_status_t	status;
	uint16_t	bfad_num;
	uint16_t	vf_id;
	wwn_t	lpwwn;
	wwn_t	rpwwn;
	struct bfa_itnim_stats_s itnstats;
} bfa_ioctl_itnim_itnstats_t;

typedef struct {
	bfa_status_t	status;
	uint16_t	bfad_num;
	uint16_t	vf_id;
	wwn_t	lpwwn;
	wwn_t	rpwwn;
} bfa_ioctl_itnim_reset_stats_t;

#endif
