/*
 * Copyright (c) 2005-2014 Brocade Communications Systems, Inc.
 * Copyright (c) 2014 QLogic Corporation.
 * All rights reserved
 * www.qlogic.com
 *
 * See LICENSE.bfa for copyright and licensing details.
 */

#ifndef __BFA_IOCTL_LPORT_H__
#define __BFA_IOCTL_LPORT_H__

#include <defs/bfa_defs_fcs.h>

#define BFA_MAX_RPORTS 1024

typedef struct {
	bfa_status_t    status;
	uint16_t	bfad_num;
	uint16_t	vf_id;
	wwn_t		pwwn;
	struct bfa_lport_attr_s port_attr;
} bfa_ioctl_lport_attr_t;

typedef struct {
	bfa_status_t    status;
	uint16_t	bfad_num;
	uint16_t	vf_id;
	wwn_t		pwwn;
	struct bfa_itnim_iostats_s iostats;
} bfa_ioctl_lport_iostats_t;

typedef struct {
	bfa_status_t    status;
	uint16_t	bfad_num;
	uint16_t	vf_id;
	wwn_t		pwwn;
	struct bfa_lport_stats_s port_stats;
} bfa_ioctl_lport_stats_t;

typedef struct {
	bfa_status_t    status;
	uint16_t	bfad_num;
	uint16_t	vf_id;
	wwn_t		pwwn;
} bfa_ioctl_lport_reset_stats_t;

typedef struct {
	bfa_status_t    status;
	uint16_t	bfad_num;
	uint16_t	vf_id;
	wwn_t		pwwn;
	uint64_t	rbuf_ptr;
	uint32_t	nrports;
	uint32_t	rsvd;
#ifdef _WINDOWS
	bfa_rport_qualifier_t rport_quals[BFA_MAX_RPORTS];
#endif
} bfa_ioctl_lport_get_rports_t;

#endif
