/*
 * Copyright (c) 2005-2014 Brocade Communications Systems, Inc.
 * Copyright (c) 2014 QLogic Corporation.
 * All rights reserved
 * www.qlogic.com
 *
 * See LICENSE.bfa for copyright and licensing details.
 */

#ifndef __BFA_IOCTL_PBIND_H__
#define __BFA_IOCTL_PBIND_H__

#include <defs/bfa_defs_pbind.h>

#define BFA_MAX_PBIND 128	/* This is the present limit */

typedef struct {
	bfa_status_t	status;
	uint32_t		nmaps;
	wwn_t			pwwn;
	char			buf[1];
} bfa_ioctl_pbind_list_t;

typedef struct {
	bfa_status_t	status;
	uint16_t		bfad_num;
	uint16_t		rsvd;
	uint32_t		flag;
	uint32_t		rsvd1;
} bfa_ioctl_pbind_cap_t;

typedef struct {
	bfa_status_t	status;
	uint8_t			bus;
	uint8_t			target;
	uint16_t		rsvd;
	wwn_t			pwwn;
	wwn_t			rpwwn;
} bfa_ioctl_pbind_set_t;

typedef struct {
	bfa_status_t	status;
	uint32_t		rsvd;
	wwn_t			pwwn;
	wwn_t			rpwwn;
} bfa_ioctl_pbind_clear_t;
#endif
