/*
 * Copyright (c) 2005-2014 Brocade Communications Systems, Inc.
 * Copyright (c) 2014 QLogic Corporation.
 * All rights reserved
 * www.qlogic.com
 *
 * See LICENSE.bfa for copyright and licensing details.
 */

#ifndef __BFA_IOCTL_RPORT_H__
#define __BFA_IOCTL_RPORT_H__

#include <defs/bfa_defs_fcs.h>

/*
 * For RPORT_ADD and RPORT_REMOVE IOCTLs
 */
typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        vf_id;
	wwn_t           pwwn;
	wwn_t           rpwwn;
} bfa_ioctl_rport_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        vf_id;
	wwn_t           pwwn;
	wwn_t           rpwwn;
	uint32_t	pid;
	uint32_t	rsvd;
	struct bfa_rport_attr_s attr;
} bfa_ioctl_rport_attr_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        vf_id;
	wwn_t           pwwn;
	wwn_t           rpwwn;
	struct bfa_rport_stats_s stats;
} bfa_ioctl_rport_stats_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        vf_id;
	wwn_t           pwwn;
	wwn_t           rpwwn;
} bfa_ioctl_rport_reset_stats_t;

typedef struct {
	bfa_status_t	status;
    	uint16_t	bfad_num;
    	uint16_t	vf_id;
    	wwn_t		pwwn;
    	wwn_t 		rpwwn;
    	uint32_t 	host;
    	uint32_t 	bus;
    	uint32_t 	target;
    	uint32_t 	lun;
} bfa_ioctl_rport_scsi_addr_t;

typedef struct {
    bfa_status_t    status;
    uint16_t        bfad_num;
    uint16_t        vf_id;
	bfa_port_speed_t speed;
	uint32_t		rsvd;
    wwn_t           pwwn;
    wwn_t           rpwwn;
} bfa_ioctl_rport_set_speed_t;
#endif
