/*
 * Copyright (c) 2005-2014 Brocade Communications Systems, Inc.
 * Copyright (c) 2014 QLogic Corporation.
 * All rights reserved
 * www.qlogic.com
 *
 * See LICENSE.bfa for copyright and licensing details.
 */

#ifndef __BFA_IOCTL_VF_H__
#define __BFA_IOCTL_VF_H__

#include <defs/bfa_defs_fcs.h>

/*
 * For VF_MODE_ENABLE, VF_MODE_DISABLE IOCTLs, VF_DEL
 */
typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        vf_id;
} bfa_ioctl_vf_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        vf_id;
	struct bfa_lport_cfg_s  port_cfg;
} bfa_ioctl_vf_add_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        rsvd;
	uint64_t        buf_ptr;
	int             nvfs;
	uint32_t        rsvd1;
} bfa_ioctl_vf_list_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        vf_id;
	struct bfa_vf_attr_s   attr;
} bfa_ioctl_vf_attr_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        vf_id;
	struct bfa_vf_stats_s  stats;
} bfa_ioctl_vf_stats_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        vf_id;
} bfa_ioctl_vf_reset_stats_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        vf_id;
	uint64_t        buf_ptr;
	int             nports;
	uint32_t        rsvd;
} bfa_ioctl_vf_get_ports_t;

#endif
