/*
 * Copyright (c) 2005-2014 Brocade Communications Systems, Inc.
 * Copyright (c) 2014 QLogic Corporation.
 * All rights reserved
 * www.qlogic.com
 *
 * See LICENSE.bfa for copyright and licensing details.
 */

#ifndef __BFA_IOCTL_VPORT_H__
#define __BFA_IOCTL_VPORT_H__

#include <defs/bfa_defs_fcs.h>

/*
 * For VPORT_DEL, VPORT_START, VPORT_STOP IOCTLs
 */
typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        vf_id;
	wwn_t           vpwwn;
	wwn_t		vnwwn;
} bfa_ioctl_vport_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        vf_id;
	wwn_t           vpwwn;
	struct bfa_lport_cfg_s  port_cfg;
} bfa_ioctl_vport_create_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        vf_id;
	wwn_t           vpwwn;
	struct bfa_vport_attr_s vport_attr;
} bfa_ioctl_vport_attr_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        vf_id;
	wwn_t           vpwwn;
	struct bfa_vport_stats_s vport_stats;
} bfa_ioctl_vport_stats_t;

typedef struct {
	bfa_status_t    status;
	uint16_t        bfad_num;
	uint16_t        vf_id;
	wwn_t           vpwwn;
} bfa_ioctl_vport_reset_stats_t;

#endif
